image: docker:stable

services:
    - docker:dind

stages:
    - quality
    - build
    - update
    - deploy

variables:
    AWS_REGION: us-west-2
    NONPROD_REPOSITORY_URL: 755012583749.dkr.ecr.us-west-2.amazonaws.com/bld/launchdarkly
    PROD_REPOSITORY_URL: 000921246627.dkr.ecr.us-west-2.amazonaws.com/bld/launchdarkly
    IMAGE_VERSION_TAG: $IMAGE_MAJOR_VERSION.$CI_PIPELINE_IID
    RELEASE_TO_PROD:
        value: 'false'
        description: 'Set value to true to release to PROD'
    PROD_DEPLOYMENT_IMAGE_TAG:
        value: ''
        description: 'Specify image tag to deploy to push to prod ecr'

.aws_nonprod_setup:
    image: docker:latest
    services:
        - docker:dind
    variables:
        PACKAGES_REGISTRY_PATH: gitlab.com/api/v4/projects/${BCOM_PACKAGES_PROJID_PROD}/packages/npm/
        PACKAGES_ACCESS_TOKEN: ${BCOM_PACKAGES_ACCESS_TOKEN_NON_PROD}
    before_script:
        - apk add --no-cache curl jq python3 py3-pip
        - pip install awscli==1.18.216
        - export AWS_ACCESS_KEY_ID=$AWS_ACCESS_KEY_ID
        - export AWS_SECRET_ACCESS_KEY=$AWS_SECRET_ACCESS_KEY
        - export AWS_REGION=$AWS_REGION
        - export AWS_DEFAULT_REGION=$AWS_REGION
        - $(aws ecr get-login --no-include-email --region "${AWS_REGION}")
    tags:
        - docker

.build_nonprod_job:
    extends: .aws_nonprod_setup
    stage: build
    script:
        - docker build
          --build-arg PACKAGES_REGISTRY_PATH=${PACKAGES_REGISTRY_PATH}
          --build-arg PACKAGES_ACCESS_TOKEN=${PACKAGES_ACCESS_TOKEN}
          -t launchdarkly -f Dockerfile .
        - docker tag launchdarkly:latest ${NONPROD_REPOSITORY_URL}:$IMAGE_VERSION_TAG
        - docker tag launchdarkly:latest ${NONPROD_REPOSITORY_URL}:latest
        - docker push ${NONPROD_REPOSITORY_URL}:$IMAGE_VERSION_TAG
        - docker push ${NONPROD_REPOSITORY_URL}:latest

build_nonprod:
    extends: .build_nonprod_job
    only:
        - develop
        - /^hotfix/.*$/
        - main

update_uat:
    extends: .aws_nonprod_setup
    stage: update
    script:
        - aws ssm put-parameter --type String --name /services/rct/bld/uat/launchdarkly/ImageTag --value $IMAGE_VERSION_TAG --overwrite
    # when: manual
    only:
        - develop
        - /^hotfix/.*$/
        - main

deploy_uat:
    stage: deploy
    variables:
        Environment: uat
        Stage: ops
        ServiceName: launchdarkly
        Project: brandlaunchdarkly
        ProjectAbr: bld
        ApplicationName: realogy-corp-tools
        ApplicationAbr: rct
        AWS_ACCESS_KEY_ID: $AWS_ACCESS_KEY_ID
        AWS_SECRET_ACCESS_KEY: $AWS_SECRET_ACCESS_KEY
        AWS_DEFAULT_REGION: $AWS_REGION
        JOB_NAME: deploy
    trigger:
        project: realogy/corporate/corpapps/realogycorptools/brand-initiatives/brand-com-ui-infra
        branch: main
    when: manual
    only:
        - develop
        - /^hotfix/.*$/
        - main


